package main

import (
	"bufio"
	"bytes"
	"encoding/binary"
	"fmt"
	"io/ioutil"
	"net"
	"time"

	"github.com/natefinch/npipe"
	"golang.org/x/text/encoding/simplifiedchinese"
	"golang.org/x/text/encoding/unicode"
	"golang.org/x/text/transform"
)

func decodeGBK(input []byte) ([]byte, error) {
	return ioutil.ReadAll(transform.NewReader(bytes.NewReader(input), simplifiedchinese.GBK.NewDecoder()))
}

func encodeGBK(input []byte) ([]byte, error) {
	return ioutil.ReadAll(transform.NewReader(bytes.NewReader(input), simplifiedchinese.GBK.NewEncoder()))
}

func handleConnection(conn net.Conn) {
	w := bufio.NewWriter(conn)
	for {
		data, err := encodeGBK([]byte("你好"))
		fmt.Println(len(data))
		if err != nil {
			fmt.Println(err)
		}
		bs := make([]byte, 4)
		binary.LittleEndian.PutUint32(bs, uint32(len(data)))
		w.Write(bs)
		w.Write(data)
		w.Flush()
		fmt.Println("send to client end:")
		time.Sleep(time.Second)
		break
	}

	if err := conn.Close(); err != nil {
		panic(err)
	}
}

func main() {
	fmt.Println("hello world!")
	ln, err := npipe.Listen(`\\.\pipe\mypipe`)
	if err != nil {
		panic(err)
	}
	for {
		conn, err := ln.Accept()
		fmt.Println("accepted")
		if err != nil {
			fmt.Println(err)
			continue
		}
		go handleConnection(conn)
	}
}
